<template>
    <div class="mx-auto px-10 py-6">
    <div class="max-w-7xl mx-auto px-4 sm:px-6 md:px-8">
      <h1 class="text-2xl font-semibold text-gray-900">Update</h1>
    </div>

    <VumikForm class="px-4 py-8 space-y-6" v-model="formData" @submit="tryUpdate()">
      <div class="grid grid-cols-1 gap-y-6 gap-x-4 sm:grid-cols-6">
        <div class="sm:col-span-3">
          <label for="title" class="block text-sm font-medium text-gray-700">
            Title
          </label>
          <div class="mt-1">
            <VumikInput type="text" name="title" placeholder="Title of the project" />
          </div>
        </div>
        <div class="sm:col-span-6">
          <label for="description" class="block text-sm font-medium text-gray-700">
            Description
          </label>
          <div class="mt-1">
            <VumikInput type="text" name="description" />
          </div>
        </div>
        <div class="sm:col-span-3">
          <label for="phoneNumber" class="block text-sm font-medium text-gray-700">
            Phone Number
          </label>
          <div class="mt-1">
            <VumikInput type="text" name="phoneNumber" />
          </div>
        </div>
        <div class="sm:col-span-3">
          <label for="email" class="block text-sm font-medium text-gray-700">
            Email
          </label>
          <div class="mt-1">
            <VumikInput type="email" name="email" />
          </div>
        </div>
        <div class="sm:col-start-5 sm:col-span-1 self-center justify-self-end">
          <router-link to="/" class="whitespace-nowrap text-base font-medium text-gray-500 hover:text-gray-900">Cancel</router-link>
        </div>
        <div class="sm:col-start-6 sm:col-span-1">
          <VumikInput type="submit" value="Send"/>
        </div>
      </div>
    </VumikForm>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
export default {
  name: 'UpdateProject',
  data () {
    return {
      formData: {
        title: this.project?.title,
        description: '',
        phoneNumber: '',
        email: ''
      }
    }
  },
  computed: {
    ...mapGetters('project', ['getOne']),
    project () {
      return this.getOne(this.$route.params.id)
    }
  },
  methods: {
    ...mapActions('project', ['updateProject']),
    tryUpdate () {
      this.updateProject({ ...this.formData, id: this.project.id }).then(() => this.$router.push({ name: 'ProjectsListUser' }))
    }
  },
  beforeMount () {
    this.formData.title = this.project?.title
    this.formData.description = this.project?.description
    this.formData.phoneNumber = this.project?.phoneNumber
    this.formData.email = this.project?.email
  }
}
</script>
